'Programm:   Demo fr den UKW-Fuchsjagd-Sender "Foxy" mit ATtiny45+MICRF102
'            Unterbrochenen Ton mit ASK senden, Strategie: Ton mit Timer1
'Sprache:    Bascom-AVR-Basic, siehe www.mcselec.com (freie Version hat fr ATtiny45 keine Einschrnkungen)
'Von:        Roland Walter, DL7UNO, www.rowalt.de
'Datum:      31.01.2007 (letzte nderung)
'Literatur:  Roland Walter: AVR-Mikrocontroller-Lehrbuch, siehe www.rowalt.de
'Kommentar:  Pin PB4 wird als Timer1-Ausgang OC1B verwendet, Timer1 erzeugt den
'            Ton selbstndig. Zustzlich Tonunterbrechung durch Timer0.
'-------------------------------------------------------------------------------
$regfile = "ATtiny45.dat"   'Deklarationen fr den ATtiny45
$crystal = 1000000          'Taktfrequenz: 1 MHz (Fabrik-Voreinstellung, Interner RC-Oszillator 8MHz mitb Vorteilung 1/8)
'
On OVF0 OnTimer0       'Bei Timer0-berlauf-Interrupt zur Routine OnTimer0 springen
'
ACSR.ACD = 0           'Analog-Komparator ausschalten, spart etwas Strom
'
DDRB  = &B00011000     'Pins PB3+PB4 als Ausgnge konfigurieren (1), Rest ist Eingang (0)
PORTB = &B00000111     'PullUp-Widerstnde fr die Pins PB0,PB1,PB2 aktivieren (Strfestigkeit)
'
PORTB.3 = 1            'Pin PB3 auf High (StandBy-Pin am MICRF102): Standby-Modus abschalten
'
'Morseton mit Timer1 erzeugen:
'Statt den Ton zu Fu durch Ein- und Ausschalten von Pin PB4 zu erzeugen, konfigurieren
'wir jetzt Timer1 so, da er dies selbstndig und unabhngig vom laufenden Programm fr
'uns tut. Sobald wir die entsprechenden 4 Timer1-Register beschickt haben, beginnt die
'Tonausgabe:
TCCR1=Bits(CS11,CS10,CTC1) 'Timer1: Vorteilung 1MHz/8, Timer-Reset bei Compare-Match
GTCCR=Bits(COM1B0)         'Timer1: Toggle Pin OC1B/PB4, wenn Register TCNT1 Wert von Compare-Register OCR1B hat
OCR1B=140                  'Timer1: Ausprobierter Vergleichswert. Wenn erreicht, dann Aktion an Pin OC1B/PB4
OCR1C=OCR1B                'Timer1: Timer-Maximalwert wie Vergleichswert setzen
'
'Ton-Takt (Unterbrechungen) mit Timer0 erzeugen:
'Wir lassen Timer0 mit niedriger Frequenz laufen und lassen bei jedem berlauf
'einen Interrupt (sozusagen rhytmisch) generieren. In der Interrupt-Routine
'schalten wir dann den Ausgabepin ein und aus:
TCCR0B=Bits(CS02,CS00)     'Timer0: Vorteilung 1MHz/1024
TIMSK=Bits(TOIE0)          'Timer0: Overflow-Interrupt einschalten
'-------------------------------------------------------------------------------
'Hauptprogramm:
SREG.SREG_I=1              'Interrupts global einschalten
Do
  'Nichts zu tun ;-)
Loop
'-------------------------------------------------------------------------------
OnTimer0:     'Timer0-berlauf-Interruptroutine
  'Wenn im Register GTCCR die Bits COM1B1 und COM1B0 beide 0 sind, dann wird der
  'Pin OC1B/PB4 (der "Sende-Pin") nicht von Timer1 gendert, d.h. es wird kein
  'Ton ausgegeben. Ansonsten wird mit GTCCR.COM1B0=1 eingestellt, da Timer1 den
  'Pin togglen (umschalten) soll. Das nutzen wir zum Takten der Morsezeichen,
  'bzw. in diesem Beispielprogramm erst einmal zum dit dit dit it dit ...
  'Bei Erweiterungen nicht vergessen, da bei Pausen der Ausgabe-Pin PB4 auf 0
  'gesetzt sein mu, damit man nicht etwa einen Trger stehen lt.
  GTCCR.COM1B0=Not GTCCR.COM1B0
Return
'-------------------------------------------------------------------------------
End